/**************************************************************************************
 Copyright (c) 2002
      The UbixOS Project

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

Redistributions of source code must retain the above copyright notice, this list of conditions, the following disclaimer and the list of authors.
Redistributions in binary form must reproduce the above copyright notice, this list of conditions, the following disclaimer and the list of authors
in the documentation and/or other materials provided with the distribution. Neither the name of the UbixOS Project nor the names of its
contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

 $Id: spinlock.c,v 1.7 2003/04/16 07:21:11 reddawg Exp $
**************************************************************************************/

#include <ubixos/spinlock.h>
#include <ubixos/schedule.h>
#include <ubixos/kpanic.h>
#include <lib/kmalloc.h>
#include <lib/string.h>


spinlock_t * spinlockCreate() {
  spinlock_t * lock = kmalloc(sizeof(spinlock_t),_current->id);
  if (lock == NULL)
    kPanic("SPINLOCK: Couldn't create spinlock\n");
    kmemset(lock, '\0', sizeof(spinlock_t));
  return(lock);
  }

void spinlockInit(spinlock_t * lock) {
  kmemset(lock, '\0', sizeof(spinlock_t));
  }

void spinlockDelete(spinlock_t * lock) {
  int i;
  int notComplete = 1;

  lock->deleteInProgress = 1;

  while (notComplete == 1) {
    notComplete = 0;
    for (i = 0; i < 16; i++) {
      while(lock->choiceInProgress[i] != 0)
        notComplete = 1;
      while(lock->ticket[i] != 0)
      notComplete = 1;
      }
    }
  kfree(lock);
  }

int spinlockLock(spinlock_t * lock, int cpuID, int act) {
  int max_ticket = 0;
  int i;

  if (lock->deleteInProgress == 1)
  return SPINLOCK_FAIL_DELETING;

  if (lock->owner == cpuID) {
    lock->count++;
    return SPINLOCK_SUCCESS;
    }

  lock->choiceInProgress[cpuID] = 1;

  for (i = 0; i < 16; i++)
    if (lock->ticket[i] >= max_ticket)
      max_ticket = lock->ticket[i];

  max_ticket++;

  lock->ticket[cpuID] = max_ticket;
  lock->choiceInProgress[cpuID] = 0;

  for (i = 0; i < 16; i++) {
    while(lock->choiceInProgress[i] == 1);
    while (((lock->ticket[i] < max_ticket) || ((lock->ticket[i] == max_ticket) && (i < cpuID))) && (lock->ticket[i] != 0));
    }
  lock->owner = cpuID;
  return SPINLOCK_SUCCESS;
  }

int spinlockUnlock(spinlock_t * lock, int cpuID) {
  if (lock->owner == cpuID) {
    lock->count--;
    if (lock->count != 0) {
      return SPINLOCK_SUCCESS;
      }
    }
  lock->ticket[cpuID] = 0;
  lock->owner = -1;
  return SPINLOCK_SUCCESS;
  }